"use strict";

(async () => {
  const DEFAULT_STYLE =
    "https://cdn.nmbrs.com/assets/css/loginTemplate.css";

  // fix button style class
  const inputContainers = document.querySelectorAll(
    `.form-group .col-sm-offset-1.col-sm-10.no-side-padding, 
		 .col-sm-4.control-label.col-no-right-padding.col-no-left-padding-sm, 
		 .col-sm-8.col-no-left-padding, 
		 .col-sm-offset-4.col-sm-12,
		 .col-sm-5.control-label.col-no-right-padding,
		 .col-sm-7.col-no-left-padding,
		 .col-sm-offset-5.col-sm-12`
  );

  if (inputContainers.length) {
    inputContainers.forEach((el) => {
      el.classList.remove(
				"col-sm-offset-1", 
				"col-sm-offset-5",
				"col-sm-10",
				"no-side-padding",
				"col-sm-4", 
				"control-label", 
				"col-no-right-padding", 
				"col-no-left-padding-sm", 
				"col-sm-8", 
				"col-no-left-padding", 
				"col-sm-offset-4", 
				"col-sm-12",
				"col-sm-5",
				"col-sm-7");

      el.classList.add("col-sm-12");
    });
  }

  const usernameInput = document.getElementById('Username');

	const passwordInput = document.getElementById('Password');

	if(usernameInput){

		try	{ usernameInput.setAttribute('placeholder', usernameInput.parentElement.querySelector('label.label-animated').textContent); }
		catch(e) { usernameInput.setAttribute('placeholder', usernameInput.parentElement.parentElement.querySelector('label[for="Username"]').textContent); }
	}

	if(passwordInput){

		try	{ passwordInput.setAttribute('placeholder', passwordInput.parentElement.querySelector('label.label-animated').textContent); }
		catch(e) { passwordInput.setAttribute('placeholder', passwordInput.parentElement.parentElement.querySelector('label[for="Password"]').textContent); }
	}

  // fetch styles
  async function getStyle(url) {
    return await fetch(url)
      .then((response) => response.text())
      .then((retval) => {
        return retval;
      });
  }

  function getCountryFromRedirectUri(redirectUri) {
    if(!redirectUri) {
      return '';
    }

    return new URL(redirectUri).host.split('.').pop();
  }

  function handleExternalProvidesVisibility(redirectUri) {
      const country = getCountryFromRedirectUri(redirectUri);

      switch(country) {
        case 'nl': 
          hideExternalProvidersNL();
          break;
        default:
          break;
      }
  } 

  function hideExternalProvidersNL(){
      setTimeout(() => {
        const bankse = document.getElementById('page-login-bankidse');
        const bankseMobile = document.getElementById('page-login-bankidse-mobile');

        if(bankse != null){
          bankse.style.display = 'none';
        }

        if(bankseMobile != null){
          bankseMobile.style.display = 'none';
        }
    });
  }

  function passwordPolicyStatus() {

    const newPasswordInput = document.querySelector('#PasswordResetForm #Password');

    if(!newPasswordInput) return;

    newPasswordInput.addEventListener('keyup', () => {

      const errorLabels = document.querySelectorAll('.popover.password-policy-popover .vismaicon-error');

      const successLabels = document.querySelectorAll('.popover.password-policy-popover .vismaicon-success');

      if(errorLabels && errorLabels.length){

        errorLabels.forEach((el) => {

          el.parentElement.style.color = '#D11525';
        })
      }

      if(successLabels && successLabels.length){

        successLabels.forEach((el) => {

          el.parentElement.style.color = '#4D8400';
        })
      }
    });
  }

  const params = new URLSearchParams(
    decodeURIComponent(document.location.search)
  );

  const redirecUriParam = params.get("redirect_uri");

	handleExternalProvidesVisibility(redirecUriParam);

  const anchor = document.createElement("a");

  anchor.href = redirecUriParam;

  // document.body.setAttribute('data-host-name', anchor.host);

  // common style
  var styleValue = await getStyle(DEFAULT_STYLE);

  const commonStyle = document.createElement("style");

  commonStyle.innerText = styleValue; 

  document.body.append(commonStyle);

  // custom style
  const hostName = anchor.host.split(".").join("").split("-").join("");

  const customStyle = document.createElement("style");

  try {
    styleValue = await getStyle(
      `https://cdn.nmbrs.com/assets/css/loginTemplate-${hostName}.css`
    );

    if (styleValue && styleValue.length && !styleValue.includes("Error")) {
      customStyle.innerText = styleValue;
      document.body.append(customStyle);
    }
  } catch (error) {
    // has no custom style
    return;
  }

  passwordPolicyStatus();
})();